package com.yeejoin.amos.boot.module.ugp.biz.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.yeejoin.amos.boot.biz.common.bo.ReginParams;
import com.yeejoin.amos.boot.module.common.api.dto.OrgUsrDto;
import com.yeejoin.amos.boot.module.common.api.entity.OrgUsr;
import com.yeejoin.amos.boot.module.common.biz.service.impl.OrgUsrServiceImpl;
import com.yeejoin.amos.boot.module.ugp.api.Enum.OrgEnum;
import com.yeejoin.amos.boot.module.ugp.api.Enum.ProjectResourceEnum;
import com.yeejoin.amos.boot.module.ugp.api.entity.Project;
import com.yeejoin.amos.boot.module.ugp.api.entity.ProjectResource;
import com.yeejoin.amos.boot.module.ugp.api.mapper.CompanyMapper;
import com.yeejoin.amos.boot.module.ugp.api.mapper.WelderMapper;
import com.yeejoin.amos.boot.module.ugp.biz.framework.BusinessIdentify;
import com.yeejoin.amos.feign.privilege.Privilege;
import com.yeejoin.amos.feign.privilege.model.AgencyUserModel;
import com.yeejoin.amos.feign.privilege.model.RoleModel;
import com.yeejoin.amos.feign.privilege.util.DesUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.typroject.tyboot.core.foundation.utils.ValidationUtil;

import java.util.*;
import java.util.stream.Collectors;

@Service
public class WelderServiceImpl {

    @Autowired
    OrgServiceImpl orgService;

    @Autowired
    ProjectServiceImpl projectService;

    @Autowired
    ProjectResourceServiceImpl projectResourceService;

    @Value("${amos.secret.key}")
    String secretKey;

    @Autowired
    OrgUsrServiceImpl orgUsrService;

    @Autowired
    WelderMapper welderMapper;

    @Autowired
    CompanyMapper companyMapper;



    /**
     * 获取当前登录所在单位下的项目中的所有焊工列表
     * @return
     */
    @BusinessIdentify
    public List<Map> getInfo(){
        List<Project> projectList = projectResourceService.getProjectList();
        List<Long> projectIdList = new ArrayList<>();
        List<Long> welderIdList = new ArrayList<>();
        for(Project project:projectList){
            projectIdList.add(project.getSequenceNbr());
        }
        for(Long projectId:projectIdList){
            LambdaQueryWrapper<ProjectResource> projectResourceWrapper = new LambdaQueryWrapper<>();
            projectResourceWrapper.eq(ProjectResource::getType, ProjectResourceEnum.焊工资源.getCode())
                    .eq(ProjectResource::getProjectId,projectId);
            List<ProjectResource> projectResourceList = projectResourceService.list(projectResourceWrapper);
            for(ProjectResource projectResource : projectResourceList){
                welderIdList.add(projectResource.getResourceId());
            }
        }
        List<Map> mapList = new ArrayList<>();
        for(Long welderId:welderIdList){
            mapList.add(orgService.getdetialInfo(String.valueOf(welderId)));
        }
        return mapList;
    }

    public IPage<Map> getpageInfo(){
        IPage<Map> page = new Page<>();
        page.setSize(getInfo().size());
        page.setCurrent(1L);
        page.setRecords(getInfo());
        page.setTotal(getInfo().size());
        return page;
    }

    /**
     * 存人员信息至业务表及平台表
     * @param jsonObject
     * @param bizOrgType
     * @param sequenceNbr
     * @return
     */
    @BusinessIdentify
    public OrgUsrDto savePerson(JSONObject jsonObject, String bizOrgType, String sequenceNbr){
        if(ValidationUtil.isEmpty(sequenceNbr)){
            Long  companyId= orgService.getReginParams().getCompany().getSequenceNbr();
            Long companyUserId =  orgService.getReginParams().getBusinessInfo().getCompanySequenceNbr();
            String orgexpand = orgService.getOrgUsrById(String.valueOf(companyUserId)).getOrgExpandAttr1();
            Set<String> roleNameSet = new HashSet<>();
            List<RoleModel> userRoleList = new ArrayList<>();
            List<Long> roleIds = new ArrayList<>();
            Map<Long, List<Long>> roleSeqsMap = new HashMap<>();
            AgencyUserModel agencyUserModel = new AgencyUserModel();
            Map<Long,List<RoleModel>> orgRoles = new HashMap<>();
            //用户基本信息
            agencyUserModel.setRealName(jsonObject.getString("name"));
            agencyUserModel.setAgencyCode("ugp");
            agencyUserModel.setLockStatus("UNLOCK");
            agencyUserModel.setMobile(jsonObject.getString("phone"));
            agencyUserModel.setCreateTime(new Date());
            agencyUserModel.setUserName(jsonObject.getString("phone"));
            agencyUserModel.setPassword(DesUtil.encode(jsonObject.getString("phone"), secretKey));
            agencyUserModel.setRePassword(DesUtil.encode(jsonObject.getString("phone"), secretKey));
            //用户角色信息和权限
            List<RoleModel> allRoleList = Privilege.roleClient.queryRoleList(null,null).getResult();
            List<String> appCodes = new ArrayList<>();
            if(orgexpand.equals(OrgEnum.安装单位.getKey())){
                if(jsonObject.getString("isWelder").equals("1")){
                    roleNameSet.add(OrgEnum.普通人员.getName());
                }else{
                    roleNameSet.add(OrgEnum.安装单位.getName());
                    String[] codes = OrgEnum.安装单位.getAppCode().split(",");
                    for(String code : codes){
                        appCodes.add(code);
                    }
                    agencyUserModel.setAppCodes(appCodes);

                }
            }else if(orgexpand.equals(OrgEnum.建设单位.getKey())){
                roleNameSet.add(OrgEnum.建设单位.getName());
                String[] codes = OrgEnum.建设单位.getAppCode().split(",");
                for(String code : codes){
                    appCodes.add(code);
                }
                agencyUserModel.setAppCodes(appCodes);
            }else if(orgexpand.equals(OrgEnum.监察部门.getKey())){
                roleNameSet.add(OrgEnum.监察部门.getName());
                String[] codes = OrgEnum.监察部门.getAppCode().split(",");
                for(String code : codes){
                    appCodes.add(code);
                }
                agencyUserModel.setAppCodes(appCodes);
            }else if(orgexpand.equals(OrgEnum.监检机构.getKey())){
                roleNameSet.add(OrgEnum.监检机构.getName());
                String[] codes = OrgEnum.监检机构.getAppCode().split(",");
                for(String code : codes){
                    appCodes.add(code);
                }
                agencyUserModel.setAppCodes(appCodes);
            }else if(orgexpand.equals(OrgEnum.设计单位.getKey())){
                roleNameSet.add(OrgEnum.设计单位.getName());
                String[] codes = OrgEnum.设计单位.getAppCode().split(",");
                for(String code : codes){
                    appCodes.add(code);
                }
            }


            //给登录人身份配置
            userRoleList = allRoleList.stream().filter(r -> {
                for(String roleName : roleNameSet){
                    if(r.getRoleName().equals(roleName)){
                        return true;
                    }
                }
                return false;
            }).collect(Collectors.toList());
            userRoleList.stream().forEach(r -> {
                if (!roleIds.contains(r.getSequenceNbr())) {
                    roleIds.add(r.getSequenceNbr());
                }
            });
            //登录人应用权限
//            List<String> appCodes = new ArrayList<>();
//            Map<String,String> map = new HashMap();
//            map.put("APPKey",OrgEnum.普通人员.getAppCode());
//            appCodes.add(map.get("APPKey"));
//            agencyUserModel.setAppCodes(appCodes);
            roleSeqsMap.put(companyId,roleIds);
            orgRoles.put(companyId,userRoleList);
            agencyUserModel.setOrgRoleSeqs(roleSeqsMap);
            agencyUserModel.setOrgRoles(orgRoles);
            //创建用户
            agencyUserModel = Privilege.agencyUserClient.create(agencyUserModel).getResult();
            jsonObject.put("amosOrgId",agencyUserModel.getSequenceNbr());
        }

        return orgService.dataHandling(jsonObject,bizOrgType,sequenceNbr);
    }

    @BusinessIdentify
    public List<Map> welderStatistics() {
        Set<String> personCode = new HashSet<>();
        Long companyIds = orgService.getReginParams().getBusinessInfo().getCompanySequenceNbr();
        String bizOrgCode = orgUsrService.getById(companyIds).getBizOrgCode();

        String companyKey = companyMapper.selectById(companyIds).getType();
        if(companyKey.equals(OrgEnum.安装单位.getKey())){
            personCode.add(String.valueOf(bizOrgCode));
        } else if (companyKey.equals(OrgEnum.监检机构.getKey())) {
            LambdaQueryWrapper<OrgUsr> wrapper = new LambdaQueryWrapper<>();
            wrapper.eq(OrgUsr::getBizOrgCode,orgUsrService.getById(companyIds).getBizOrgCode());
            List<OrgUsr> selectCodes = orgUsrService.list(wrapper);
            for(OrgUsr selectCode : selectCodes){
                personCode.add(String.valueOf(selectCode.getBizOrgCode()));
            }
        } else if (companyKey.equals(OrgEnum.监察部门.getKey())) {
            LambdaQueryWrapper<OrgUsr> wrapper = new LambdaQueryWrapper<>();
            wrapper.eq(OrgUsr::getSequenceNbr,orgUsrService.getById(companyIds).getParentId());
            List<OrgUsr> selectCodes = orgUsrService.list(wrapper);
            for(OrgUsr selectCode : selectCodes){
                personCode.add(String.valueOf(selectCode.getBizOrgCode()));
            }
        }
        return welderMapper.welderStatistics(personCode);
    }
}
